import { RadialBucketCalculator } from "./RadialBucketCalculator";
import { IFastItemColumn$1 } from "igniteui-angular-core/ES2015/IFastItemColumn$1";
import { Type, Point } from "igniteui-angular-core/ES2015/type";
import { RadialBase } from "./RadialBase";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { DependencyProperty } from "igniteui-angular-core/ES2015/DependencyProperty";
import { TrendLineType } from "igniteui-angular-core/ES2015/TrendLineType";
import { Brush } from "igniteui-angular-core/ES2015/Brush";
import { PenLineCap } from "igniteui-angular-core/ES2015/PenLineCap";
import { DoubleCollection } from "igniteui-angular-core/ES2015/DoubleCollection";
import { RadialFrame } from "./RadialFrame";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { AxisRange } from "./AxisRange";
import { RadialBaseView } from "./RadialBaseView";
import { FastItemsSourceEventAction } from "igniteui-angular-core/ES2015/FastItemsSourceEventAction";
import { CategoryAngleAxis } from "./CategoryAngleAxis";
import { Clipper } from "igniteui-angular-core/ES2015/Clipper";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { RadialTrendLineManager } from "./RadialTrendLineManager";
import { PointCollection } from "igniteui-angular-core/ES2015/PointCollection";
import { RenderSurface } from "./RenderSurface";
import { RenderingContext } from "igniteui-angular-core/ES2015/RenderingContext";
/**
 * @hidden
 */
export declare class AnchoredRadialBucketCalculator extends RadialBucketCalculator {
    static $t: Type;
    private f;
    constructor(a: AnchoredRadialSeriesView);
    getBucket(a: number): number[];
}
/**
 * @hidden
 */
export declare abstract class AnchoredRadialSeries extends RadialBase {
    static $t: Type;
    protected bf(): SeriesView;
    ht(): void;
    fs(a: any, b: string): any;
    it(a: SeriesView): void;
    np: AnchoredRadialSeriesView;
    constructor();
    nq: CategoryLineRasterizer;
    fe(a: Point, b: boolean): number;
    fc(a: Point, b: boolean): number;
    d9(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    en(a: Point, b: boolean, c: boolean): number;
    lk(a: Point, b: boolean, c: boolean): Point;
    n7: string;
    nv: IFastItemColumn$1<number>;
    private nu;
    nt: TrendLineType;
    ol: Brush;
    ok: Brush;
    static readonly ob: DependencyProperty;
    n3: number;
    on: PenLineCap;
    om: DoubleCollection;
    n4: number;
    n5: number;
    an(a: Axis): AxisRange;
    protected iy(a: any, b: string, c: any, d: any): void;
    protected hy(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    dw(a: Rect, b: Rect, c: SeriesView): boolean;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    protected get_ny(): boolean;
    protected readonly ny: boolean;
    protected n0(a: CategoryAngleAxis, b: Rect, c: Rect, d: Rect): number;
    nj(a: RadialFrame, b: RadialBaseView): void;
    private n1;
    private n2;
    private nz;
    no(a: List$1<number[]>, b: number, c: SeriesView): Clipper;
    protected oo: Point;
    oa(a: PointCollection, b: PointCollection, c: PointCollection, d: PointCollection, e: boolean): void;
    private nx;
    private nw;
    hv(a: boolean, b: SeriesView): void;
    nk(a: RadialFrame, b: RadialBaseView): void;
    private n9;
    protected jn(): void;
    fv(a: any, b: Point): any;
    c9(a: any): boolean;
    ns: RadialFrame;
    je(a: Rect, b: RenderSurface): void;
    private nr;
    jb(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    protected h4(a: any): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AnchoredRadialSeriesView extends RadialBaseView {
    static $t: Type;
    cs: AnchoredRadialSeries;
    constructor(a: AnchoredRadialSeries);
    ct: RadialTrendLineManager;
    cu(a: Rect, b: Rect, c: Rect, d: Rect): void;
    cv(): void;
    protected a2(a: RenderingContext, b: boolean): void;
    getDefaultTooltipTemplate(): string;
}
