import { Series } from "./Series";
import { Point, Type } from "igniteui-angular-core/ES2015/type";
import { Frame } from "./Frame";
import { SeriesView } from "./SeriesView";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { NotifyCollectionChangedEventArgs } from "igniteui-angular-core/ES2015/NotifyCollectionChangedEventArgs";
import { Axis } from "./Axis";
import { Brush } from "igniteui-angular-core/ES2015/Brush";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { Tuple$2 } from "igniteui-angular-core/ES2015/Tuple$2";
/**
 * @hidden
 */
export declare abstract class AnnotationLayer extends Series {
    static $t: Type;
    constructor();
    protected bf(): SeriesView;
    it(a: SeriesView): void;
    protected l7(a: Series): boolean;
    protected lz: AnnotationLayerView;
    l9: boolean;
    ma: boolean;
    m1: Point;
    l4: boolean;
    protected get_cm(): boolean;
    protected bd(): SeriesHitTestMode;
    protected get_cw(): boolean;
    protected get_isUsableInLegend(): boolean;
    protected iy(a: any, b: string, c: any, d: any): void;
    protected m2: Point;
    private mt;
    private ms;
    private mo;
    private mn;
    protected l5(a: Axis): boolean;
    private mh;
    protected l6(a: Series): boolean;
    private mr;
    protected mj(a: Axis, b: boolean): void;
    protected mk(a: Series, b: boolean): void;
    private mq;
    private mg;
    protected my(): Brush;
    protected mz(): Brush;
    protected mi(a: NotifyCollectionChangedEventArgs): void;
    protected ml(a: NotifyCollectionChangedEventArgs): void;
    protected l1: Frame;
    protected l0: Frame;
    protected l2: Frame;
    protected js(a: Rect, b: Rect): void;
    protected jr(a: Rect, b: Rect): void;
    jd(a: boolean): void;
    protected get_cj(): boolean;
    protected mm(a: Frame, b: SeriesView): void;
    protected mp(a: Frame, b: SeriesView): void;
    protected mf(a: Series): Tuple$2<boolean, Point>;
    protected io(a: Point): void;
    m0: Point;
    dw(a: Rect, b: Rect, c: SeriesView): boolean;
    protected get_ds(): boolean;
    private l3;
    l8: boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AnnotationLayerView extends SeriesView {
    static $t: Type;
    constructor(a: AnnotationLayer);
    protected bu: AnnotationLayer;
    private bv;
    private bw;
    private b0;
    bx(): void;
    bz(): void;
    by(): void;
}
