import { AnnotationLayer } from "./AnnotationLayer";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "igniteui-angular-core/ES2015/DependencyProperty";
import { CategoryHighlightLayerFrame } from "./CategoryHighlightLayerFrame";
import { Type } from "igniteui-angular-core/ES2015/type";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { Frame } from "./Frame";
import { CategoryHighlightFrameRect } from "./CategoryHighlightFrameRect";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { Pool$1 } from "igniteui-angular-core/ES2015/Pool$1";
import { Rectangle } from "igniteui-angular-core/ES2015/Rectangle";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { Brush } from "igniteui-angular-core/ES2015/Brush";
import { RenderingContext } from "igniteui-angular-core/ES2015/RenderingContext";
/**
 * @hidden
 */
export declare class CategoryHighlightLayer extends AnnotationLayer {
    static $t: Type;
    constructor();
    protected bf(): SeriesView;
    it(a: SeriesView): void;
    protected m4: CategoryHighlightLayerView;
    m3: CategoryAxisBase;
    m6: boolean;
    m7: number;
    static readonly ne: DependencyProperty;
    protected mj(a: Axis, b: boolean): void;
    private m5;
    protected mm(a: Frame, b: SeriesView): void;
    private nc;
    nb(a: Rect, b: CategoryHighlightLayerFrame, c: Axis): void;
    protected mp(a: Frame, b: SeriesView): void;
    protected c8(): boolean;
    nd(a: CategoryHighlightFrameRect, b: Rectangle): void;
    protected iy(a: any, b: string, c: any, d: any): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CategoryHighlightLayerView extends AnnotationLayerView {
    static $t: Type;
    constructor(a: CategoryHighlightLayer);
    protected b1: CategoryHighlightLayer;
    b2: Pool$1<Rectangle>;
    ap(): void;
    protected b3: List$1<Rectangle>;
    private ca;
    private b5;
    private b7;
    private b6;
    b8(a: Brush): Brush;
    b9(a: Brush): Brush;
    b4(a: Rectangle, b: number, c: number, d: number, e: number): void;
    protected a3(a: RenderingContext, b: boolean): void;
    ai(a: any): void;
}
