import { AnchoredCategorySeries } from "./AnchoredCategorySeries";
import { IHorizontalAnchoredCategorySeriesInteractionManager } from "./IHorizontalAnchoredCategorySeriesInteractionManager";
import { Type, Point } from "igniteui-angular-core/ES2015/type";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { NumericAxisBase } from "./NumericAxisBase";
import { CategoryMode } from "./CategoryMode";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { ScalerParams } from "./ScalerParams";
import { Axis } from "./Axis";
import { FastItemsSourceEventAction } from "igniteui-angular-core/ES2015/FastItemsSourceEventAction";
/**
 * @hidden
 */
export declare abstract class HorizontalAnchoredCategorySeries extends AnchoredCategorySeries {
    static $t: Type;
    private p1;
    readonly p2: IHorizontalAnchoredCategorySeriesInteractionManager;
    ht(): void;
    xAxis: CategoryAxisBase;
    yAxis: NumericYAxis;
    protected bd(): SeriesHitTestMode;
    m5(): CategoryAxisBase;
    np(): NumericAxisBase;
    lv(a: Point): Rect;
    private qf;
    protected p7(a: Point, b: Point, c: boolean): boolean;
    ah(a: Point): Point[][];
    ai(a: Point): Point[][];
    dh(a: Point, b: boolean): boolean;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    en(a: Point, b: boolean, c: boolean): number;
    fe(a: Point, b: boolean): number;
    fc(a: Point, b: boolean): number;
    d9(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    lk(a: Point, b: boolean, c: boolean): Point;
    fetchXAxis(): Axis;
    fetchYAxis(): Axis;
    pf(a: Axis): void;
    pg(a: Axis): void;
    n0(): boolean;
    protected px: CategoryAxisBase;
    protected p3: NumericAxisBase;
    qb(a: CategoryAxisBase): void;
    qc(a: NumericYAxis): void;
    mz(a: number, b: number): any[];
    protected iy(a: any, b: string, c: any, d: any): void;
    protected hy(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    p5(a: any): boolean;
    p6(a: any): boolean;
    private pz;
    p0: CategoryMode;
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
}
