/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { ItemwiseStrategyCalculationStrategy } from "./ItemwiseStrategyCalculationStrategy";
import { markType } from "igniteui-angular-core/ES2015/type";
/**
 * @hidden
 */
export class ItemwiseStrategyBasedIndicator extends StrategyBasedIndicator {
    constructor() {
        super();
    }
    get_qb() {
        return new ItemwiseStrategyCalculationStrategy();
    }
    get qb() {
        return this.get_qb();
    }
    qp() {
        super.qp();
        this.qw = this.qx;
        this.qa.c = this.qw;
    }
}
ItemwiseStrategyBasedIndicator.$t = markType(ItemwiseStrategyBasedIndicator, 'ItemwiseStrategyBasedIndicator', StrategyBasedIndicator.$);
//# sourceMappingURL=ItemwiseStrategyBasedIndicator.js.map