import { NumericAxisBase } from "./NumericAxisBase";
import { NumericScaleMode } from "./NumericScaleMode";
import { DependencyProperty } from "igniteui-angular-core/ES2015/DependencyProperty";
import { NumericScaler } from "./NumericScaler";
import { Type } from "igniteui-angular-core/ES2015/type";
import { AxisView } from "./AxisView";
import { NumericAxisBaseView } from "./NumericAxisBaseView";
/**
 * @hidden
 */
export declare abstract class StraightNumericAxisBase extends NumericAxisBase {
    static $t: Type;
    constructor();
    a1(): AxisView;
    gr(a: AxisView): void;
    lg: StraightNumericAxisBaseView;
    lb: NumericScaleMode;
    static readonly lt: DependencyProperty;
    lf: NumericScaler;
    private static lp;
    protected le(): NumericScaler;
    protected ld: NumericScaler;
    protected get_lc(): NumericScaler;
    protected set_lc(a: NumericScaler): void;
    lc: NumericScaler;
    ky(a: NumericAxisBase, b: number, c: number, d: boolean, e: number, f: number, g: number): {
        p5: number;
        p6: number;
    };
    private lq;
    private lh;
    protected lr(): void;
    lm(): void;
    protected gt(a: any, b: string, c: any, d: any): void;
    private lo;
    private ln;
    protected li(a: number, b: StraightNumericAxisBase): number;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StraightNumericAxisBaseView extends NumericAxisBaseView {
    static $t: Type;
    protected bg: StraightNumericAxisBase;
    constructor(a: StraightNumericAxisBase);
    bh(): void;
}
