import { FinancialIndicator } from "./FinancialIndicator";
import { IndicatorCalculationStrategy } from "./IndicatorCalculationStrategy";
import { Type, IList$1 } from "igniteui-angular-core/ES2015/type";
import { DependencyProperty } from "igniteui-angular-core/ES2015/DependencyProperty";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { FinancialCalculationDataSource } from "./FinancialCalculationDataSource";
/**
 * @hidden
 */
export declare abstract class StrategyBasedIndicator extends FinancialIndicator {
    static $t: Type;
    constructor();
    protected qp(): void;
    protected qa: IndicatorCalculationStrategy;
    protected abstract readonly qb: IndicatorCalculationStrategy;
    protected abstract readonly qo: Type;
    static qe: List$1<string>;
    protected qh(): number;
    qq(a: number): void;
    protected qj(): number;
    protected qg(): number;
    static qu(a: number, b: Type, c: string): DependencyProperty;
    protected static qt(a: number, b: Type): DependencyProperty;
    protected static qr(a: number, b: Type): DependencyProperty;
    protected static qv(a: number, b: Type): DependencyProperty;
    protected pn(a: number, b: number): IList$1<string>;
    protected pk(a: number, b: number): boolean;
    protected qd(a: FinancialCalculationDataSource): boolean;
    private qc;
    protected qi(a: number): number;
    protected mj(a: number, b: number): FinancialCalculationDataSource;
    protected qf(): number;
    protected static qs(a: number, b: Type): DependencyProperty;
    protected iy(a: any, b: string, c: any, d: any): void;
}
