import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IndicatorCalculationStrategy } from "./IndicatorCalculationStrategy";
import { Type } from "igniteui-angular-core/ES5/type";
import { DependencyProperty } from "igniteui-angular-core/ES5/DependencyProperty";
/**
 * @hidden
 */
export declare class BollingerBandWidthIndicator extends StrategyBasedIndicator {
    static $t: Type;
    protected get_qb(): IndicatorCalculationStrategy;
    protected readonly qb: IndicatorCalculationStrategy;
    protected get_qo(): Type;
    protected readonly qo: Type;
    qx: number;
    static readonly q0: DependencyProperty;
    protected qh(): number;
    qw: number;
    static readonly qz: DependencyProperty;
    protected qf(): number;
}
