import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IShortPeriodLongPeriod } from "./IShortPeriodLongPeriod";
import { IndicatorCalculationStrategy } from "./IndicatorCalculationStrategy";
import { Type } from "igniteui-angular-core/ES5/type";
import { DependencyProperty } from "igniteui-angular-core/ES5/DependencyProperty";
/**
 * @hidden
 */
export declare class ChaikinOscillatorIndicator extends StrategyBasedIndicator implements IShortPeriodLongPeriod {
    static $t: Type;
    protected get_qb(): IndicatorCalculationStrategy;
    protected readonly qb: IndicatorCalculationStrategy;
    protected get_qo(): Type;
    protected readonly qo: Type;
    shortPeriod: number;
    static readonly qx: DependencyProperty;
    protected qj(): number;
    longPeriod: number;
    static readonly qw: DependencyProperty;
    protected qg(): number;
}
