import { ScatterTriangulationSeries } from "./ScatterTriangulationSeries";
import { IFastItemColumn$1 } from "igniteui-angular-core/ES5/IFastItemColumn$1";
import { Type, Point } from "igniteui-angular-core/ES5/type";
import { ValueBrushScale } from "./ValueBrushScale";
import { ContourValueResolver } from "./ContourValueResolver";
import { SeriesView } from "./SeriesView";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { RenderSurface } from "./RenderSurface";
import { List$1 } from "igniteui-angular-core/ES5/List$1";
import { DataContext } from "igniteui-angular-core/ES5/DataContext";
import { Path } from "igniteui-angular-core/ES5/Path";
import { RenderingContext } from "igniteui-angular-core/ES5/RenderingContext";
/**
 * @hidden
 */
export declare class ScatterContourSeries extends ScatterTriangulationSeries {
    static $t: Type;
    constructor();
    fs(a: any, b: string): any;
    private ni;
    protected bf(): SeriesView;
    no: string;
    private nk;
    nl: IFastItemColumn$1<number>;
    protected iy(a: any, b: string, c: any, d: any): void;
    hv(a: boolean, b: SeriesView): void;
    jd(a: boolean): void;
    jb(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    protected nr(a: SeriesView): void;
    nj: ValueBrushScale;
    private ng;
    nh: ContourValueResolver;
    private ns;
    dw(a: Rect, b: Rect, c: SeriesView): boolean;
    ar(a: Point, b: boolean): DataContext;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ScatterContourSeriesView extends SeriesView {
    static $t: Type;
    private bw;
    private bv;
    constructor(a: ScatterContourSeries);
    protected by: List$1<Path>;
    private b5;
    private b1;
    private b2;
    private b3;
    private bx;
    private bu;
    bz(a: List$1<List$1<List$1<Point>>>, b: number[]): void;
    protected bb(a: any, b: number): void;
    protected bc(a: any, b: number): void;
    protected a3(a: RenderingContext, b: boolean): void;
    b0(a: boolean): void;
    ai(a: any): void;
    getDefaultTooltipTemplate(): string;
    b4(a: Point, b: boolean): Path;
}
