import { CalculatedColumn as CalculatedColumn_internal } from "./CalculatedColumn";
import { EnumeratorWrapper } from "igniteui-angular-core/ES5/type";
/**
 * Represents a column that is calculated based on the values of other columns.
*
* Represents a column that is calculated based on the values of other columns.
*
* <https://www.infragistics.com/help/wpf/infragisticswpf.controls.charts.xamdatachart~infragistics.controls.charts.calculatedcolumn>
*/
export declare class CalculatedColumn {
    protected _implementation: any;
    readonly i: CalculatedColumn_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    [Symbol.iterator](): EnumeratorWrapper<number>;
}
