import { MarkerSeries } from "./MarkerSeries";
import { Point, Type } from "igniteui-angular-core/ES2015/type";
import { PolarAxisInfoCache } from "./PolarAxisInfoCache";
import { SeriesRenderer$2 } from "./SeriesRenderer$2";
import { PolarFrame } from "./PolarFrame";
import { DependencyProperty } from "igniteui-angular-core/ES2015/DependencyProperty";
import { IFastItemColumn$1 } from "igniteui-angular-core/ES2015/IFastItemColumn$1";
import { NumericAngleAxis } from "./NumericAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { TrendLineType } from "igniteui-angular-core/ES2015/TrendLineType";
import { Brush } from "igniteui-angular-core/ES2015/Brush";
import { PenLineCap } from "igniteui-angular-core/ES2015/PenLineCap";
import { DoubleCollection } from "igniteui-angular-core/ES2015/DoubleCollection";
import { SeriesView } from "./SeriesView";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Axis } from "./Axis";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { PolarAxes } from "./PolarAxes";
import { FastItemsSourceEventAction } from "igniteui-angular-core/ES2015/FastItemsSourceEventAction";
import { AxisRange } from "./AxisRange";
import { HashPool$2 } from "igniteui-angular-core/ES2015/HashPool$2";
import { OwnedPoint } from "./OwnedPoint";
import { MarkerManagerBase } from "./MarkerManagerBase";
import { PolarTrendLineManager } from "./PolarTrendLineManager";
import { RenderSurface } from "./RenderSurface";
import { IDictionary$2 } from "igniteui-angular-core/ES2015/IDictionary$2";
import { RenderingContext } from "igniteui-angular-core/ES2015/RenderingContext";
/**
 * @hidden
 */
export declare abstract class PolarBase extends MarkerSeries {
    static $t: Type;
    protected bf(): SeriesView;
    it(a: SeriesView): void;
    m6: PolarBaseView;
    private m7;
    ht(): void;
    protected get_c0(): boolean;
    nm(a: List$1<SeriesPointOfInterest>): boolean;
    constructor();
    private n6;
    private n7;
    private m0;
    m5: PolarAxisInfoCache;
    private ox;
    private ow;
    nd: SeriesRenderer$2<PolarFrame, PolarBaseView>;
    nv: string;
    n1: string;
    protected nh: IFastItemColumn$1<number>;
    private nf;
    protected ni: IFastItemColumn$1<number>;
    private ng;
    m2: NumericAngleAxis;
    m3: NumericRadiusAxis;
    nn: boolean;
    nq: number;
    ne: TrendLineType;
    or: Brush;
    oq: Brush;
    static readonly ob: DependencyProperty;
    np: number;
    ot: PenLineCap;
    os: DoubleCollection;
    nr: number;
    ns: number;
    nl: boolean;
    na: PolarFrame;
    nc: PolarFrame;
    m9: PolarFrame;
    m4: PolarAxes;
    ia(): void;
    protected hy(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected jr(a: Rect, b: Rect): void;
    protected js(a: Rect, b: Rect): void;
    dw(a: Rect, b: Rect, c: SeriesView): boolean;
    jd(a: boolean): void;
    private ov;
    an(a: Axis): AxisRange;
    c9(a: any): boolean;
    fp(a: Point): any;
    e8(a: Point): number;
    ag(): Axis[];
    fs(a: any, b: string): any;
    protected iy(a: any, b: string, c: any, d: any): void;
    nk(a: any): boolean;
    nj(a: any): boolean;
    hv(a: boolean, b: SeriesView): void;
    private m1;
    n5(a: PolarFrame, b: number, c: Rect, d: Rect): void;
    n8(a: PolarFrame, b: PolarBaseView): void;
    oa(a: PolarFrame, b: PolarBaseView): void;
    private n4;
    protected jn(): void;
    nb: PolarFrame;
    je(a: Rect, b: RenderSurface): void;
    private m8;
    jb(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    n9(a: IDictionary$2<any, OwnedPoint>, b: HashPool$2<any, Marker>): void;
    mz(a: HashPool$2<any, Marker>, b: Rect, c: Rect): Point[];
    no(a: HashPool$2<any, Marker>): List$1<number>;
    ou(a: number): Point;
    protected h4(a: any): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class PolarBaseView extends MarkerSeriesView {
    static $t: Type;
    protected cq: PolarBase;
    cp: MarkerManagerBase;
    constructor(a: PolarBase);
    cr: PolarTrendLineManager;
    ap(): void;
    protected co(): MarkerManagerBase;
    protected cv(a: IDictionary$2<any, OwnedPoint>): void;
    protected cn(): Point[];
    protected ct(): List$1<number>;
    cu(a: Rect, b: Rect, c: Rect, d: Rect): void;
    cw(): void;
    cs: HashPool$2<any, Marker>;
    cc(a: (arg1: Marker) => void): void;
    protected a2(a: RenderingContext, b: boolean): void;
    protected cx(): Rect;
    getDefaultTooltipTemplate(): string;
}
