import { Series } from "./Series";
import { DependencyObject } from "igniteui-angular-core/ES2015/DependencyObject";
import { IFastItemColumn$1 } from "igniteui-angular-core/ES2015/IFastItemColumn$1";
import { Point, Type } from "igniteui-angular-core/ES2015/type";
import { NumericXAxis } from "./NumericXAxis";
import { NumericYAxis } from "./NumericYAxis";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { Axis } from "./Axis";
import { FlattenedShape } from "./FlattenedShape";
import { SeriesView } from "./SeriesView";
import { RenderSurface } from "./RenderSurface";
import { Dictionary$2 } from "igniteui-angular-core/ES2015/Dictionary$2";
import { FastItemsSourceEventAction } from "igniteui-angular-core/ES2015/FastItemsSourceEventAction";
import { DataContext } from "igniteui-angular-core/ES2015/DataContext";
import { FrameworkElement } from "igniteui-angular-core/ES2015/FrameworkElement";
import { AxisRange } from "./AxisRange";
import { Style } from "igniteui-angular-core/ES2015/Style";
import { StyleShapeEventArgs } from "./StyleShapeEventArgs";
import { Path } from "igniteui-angular-core/ES2015/Path";
import { Pool$1 } from "igniteui-angular-core/ES2015/Pool$1";
import { StyleSelector } from "./StyleSelector";
import { PointCollection } from "igniteui-angular-core/ES2015/PointCollection";
import { PathGeometry } from "igniteui-angular-core/ES2015/PathGeometry";
import { RenderingContext } from "igniteui-angular-core/ES2015/RenderingContext";
/**
 * @hidden
 */
export declare abstract class ShapeSeriesBase extends Series {
    static $t: Type;
    constructor();
    ht(): void;
    ag(): Axis[];
    fs(a: any, b: string): any;
    ms: string;
    private l9;
    ma: IFastItemColumn$1<any>;
    l5: NumericXAxis;
    l7: NumericYAxis;
    private md;
    private convertToListList;
    protected by(a: string): IFastItemColumn$1<any>;
    protected iy(a: any, b: string, c: any, d: any): void;
    mc(a: any): boolean;
    mb(a: any): boolean;
    private l4;
    private l6;
    private ml;
    mh: List$1<Rect>;
    private mz;
    private m7;
    private mj;
    private l0;
    private l2;
    private l1;
    private lz;
    protected get_me(): boolean;
    protected readonly me: boolean;
    protected mg(): boolean;
    jd(a: boolean): void;
    jb(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    protected my(a: SeriesView): void;
    ia(): void;
    protected js(a: Rect, b: Rect): void;
    protected jr(a: Rect, b: Rect): void;
    protected hy(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    dw(a: Rect, b: Rect, c: SeriesView): boolean;
    protected get_mf(): boolean;
    protected readonly mf: boolean;
    it(a: SeriesView): void;
    private l8;
    private mk;
    private l3;
    private mw;
    m6: Rect;
    private m1;
    hv(a: boolean, b: SeriesView): void;
    private mx;
    private m0;
    ar(a: Point, b: boolean): DataContext;
    mp(a: number): any;
    protected get_dq(): boolean;
    protected set_dq(a: boolean): void;
    mm: number;
    mn: number;
    an(a: Axis): AxisRange;
    protected get_c5(): boolean;
    m8(a: any, b: DependencyObject, c: Style): Style;
    styleShape: (sender: any, e: StyleShapeEventArgs) => void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class ShapeSeriesViewBase extends SeriesView {
    static $t: Type;
    constructor(a: ShapeSeriesBase);
    b3: Dictionary$2<number, FlattenedShape>;
    protected b0(): Pool$1<FrameworkElement>;
    b2(a: Rect): boolean;
    static b5(a: List$1<FlattenedShape>): List$1<PointCollection>;
    protected by: ShapeSeriesBase;
    private b4;
    b8(a: number, b: any, c: Rect, d: List$1<FlattenedShape>): void;
    protected ct(a: number, b: any): FrameworkElement;
    protected abstract ca(a: FrameworkElement, b: PathGeometry): void;
    static cb(a: ShapeSeriesViewBase, b: Path, c: any): void;
    protected cc(a: FrameworkElement, b: any): void;
    protected ce(a: FrameworkElement): void;
    private b9;
    private cm;
    protected abstract cu(a: number, b: List$1<PointCollection>): PathGeometry;
    cj(): void;
    ci(): void;
    private b7;
    cl(a: number, b: number): void;
    cd(): void;
    protected b6: List$1<Path>;
    cq(): FrameworkElement;
    cf(a: FrameworkElement): void;
    cg(a: FrameworkElement): void;
    ch(a: FrameworkElement): void;
    protected b1: Pool$1<FrameworkElement>;
    cv(a: number, b: List$1<PointCollection>, c: boolean): PathGeometry;
    protected bb(a: any, b: number): void;
    protected bc(a: any, b: number): void;
    protected a3(a: RenderingContext, b: boolean): void;
    private bz;
    private cw;
    co(a: StyleSelector): void;
    cn(a: Style): void;
    cr(a: Point, b: boolean): FrameworkElement;
    cs(a: Point, b: boolean, c: boolean): FrameworkElement;
    private bv;
    private bx;
    private bw;
    private bu;
    ck(a: number[], b: number[], c: number[], d: number[]): void;
    cp(): void;
    ai(a: any): void;
}
