/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { TypicalPriceIndicatorStrategy } from "./TypicalPriceIndicatorStrategy";
import { markType } from "igniteui-angular-core/ES2015/type";
/**
 * @hidden
 */
export class TypicalPriceIndicator extends StrategyBasedIndicator {
    get_qb() {
        return new TypicalPriceIndicatorStrategy();
    }
    get qb() {
        return this.get_qb();
    }
    get_qo() {
        return TypicalPriceIndicator.$;
    }
    get qo() {
        return this.get_qo();
    }
}
TypicalPriceIndicator.$t = markType(TypicalPriceIndicator, 'TypicalPriceIndicator', StrategyBasedIndicator.$);
//# sourceMappingURL=TypicalPriceIndicator.js.map