import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "igniteui-angular-core/ES5/DependencyProperty";
import { AxisOrientation } from "./AxisOrientation";
import { AxisView } from "./AxisView";
import { Type, IList$1 } from "igniteui-angular-core/ES5/type";
import { AxisLabelPanelBase } from "./AxisLabelPanelBase";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { ScalerParams } from "./ScalerParams";
import { SeriesViewer } from "./SeriesViewer";
import { CategoryMode } from "./CategoryMode";
import { IGetItemAtIndex } from "igniteui-angular-core/ES5/IGetItemAtIndex";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
/**
 * @hidden
 */
export declare class CategoryXAxis extends CategoryAxisBase {
    static $t: Type;
    a1(): AxisView;
    gr(a: AxisView): void;
    kw: CategoryXAxisView;
    constructor();
    private k8;
    la: number;
    private k7;
    k9: number;
    as(): AxisLabelPanelBase;
    getCategorySize(a: Rect, b: Rect, c: Rect): number;
    jq(a: Rect, b: Rect, c: Rect): number;
    getGroupCenter(a: number, b: Rect, c: Rect, d: Rect): number;
    di(): number;
    lf(a: any): void;
    dv(a: number, b: ScalerParams): number;
    protected kv(a: IList$1<number[]>): number[][];
    gl(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    dw(a: number, b: ScalerParams, c: CategoryMode): number;
    private k4;
    dy(a: number, b: ScalerParams): number;
    dz(a: number, b: ScalerParams, c: CategoryMode): number;
    getUnscaledValue3(a: number, b: Rect, c: Rect, d: CategoryMode): number;
    lg(a: number, b: number): void;
    protected g6(a: boolean): void;
    cm(): boolean;
    static readonly lh: DependencyProperty;
    k5: number;
    private ky;
    k0: number;
    d6(): number;
    static readonly li: DependencyProperty;
    k6: number;
    private kz;
    k1: number;
    jh(a: SeriesViewer): boolean;
    protected get_az(): AxisOrientation;
    readonly az: AxisOrientation;
    protected kx(): IGetItemAtIndex;
    protected k3(a: number, b: ScalerParams): number;
    protected k2(a: number, b: number, c: boolean, d: ScalerParams): number;
    readonly isVertical: boolean;
    j$c(a: number, b: ScalerParams): number;
    j$b(a: number, b: ScalerParams): number;
    j$d(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$e(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    readonly j$a: boolean;
}
/**
 * @hidden
 */
export declare class CategoryXAxisView extends CategoryAxisBaseView {
    static $t: Type;
    protected bg: CategoryXAxis;
    constructor(a: CategoryXAxis);
}
