import { AnnotationLayer } from "./AnnotationLayer";
import { Brush } from "igniteui-angular-core/ES5/Brush";
import { Series } from "./Series";
import { Thickness } from "igniteui-angular-core/ES5/Thickness";
import { Visibility } from "igniteui-angular-core/ES5/Visibility";
import { CrosshairLayerFrame } from "./CrosshairLayerFrame";
import { List$1 } from "igniteui-angular-core/ES5/List$1";
import { Pool$1 } from "igniteui-angular-core/ES5/Pool$1";
import { Type } from "igniteui-angular-core/ES5/type";
import { SeriesView } from "./SeriesView";
import { Frame } from "./Frame";
import { Path } from "igniteui-angular-core/ES5/Path";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { RenderingContext } from "igniteui-angular-core/ES5/RenderingContext";
/**
 * @hidden
 */
export declare class CrosshairLayer extends AnnotationLayer {
    static $t: Type;
    constructor();
    protected bf(): SeriesView;
    it(a: SeriesView): void;
    protected m5: CrosshairLayerView;
    o9: Brush;
    pa: Brush;
    m6: Series;
    nb: boolean;
    m9: boolean;
    xAxisAnnotationFormatLabel: (item: any) => string;
    m7(): boolean;
    yAxisAnnotationFormatLabel: (item: any) => string;
    m8(): boolean;
    pd: Brush;
    pb: Brush;
    no: number;
    pc: Brush;
    readonly ph: Thickness;
    nf: number;
    nh: number;
    ng: number;
    ne: number;
    readonly pi: Thickness;
    nk: number;
    nm: number;
    nl: number;
    nj: number;
    ni: number;
    pg: Brush;
    pe: Brush;
    np: number;
    pf: Brush;
    nn: number;
    pk: Visibility;
    pj: Visibility;
    na: boolean;
    protected mk(a: Series, b: boolean): void;
    protected mm(a: Frame, b: SeriesView): void;
    protected l7(a: Series): boolean;
    im(): void;
    private oh;
    private nd;
    private nc;
    protected oi(a: CrosshairLayerFrame, b: boolean): void;
    private og;
    protected mp(a: Frame, b: SeriesView): void;
    protected c8(): boolean;
    protected iy(a: any, b: string, c: any, d: any): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CrosshairLayerView extends AnnotationLayerView {
    static $t: Type;
    constructor(a: CrosshairLayer);
    protected b1: CrosshairLayer;
    b2: Pool$1<Path>;
    protected b3: List$1<Path>;
    ap(): void;
    private b9;
    private b4;
    private b6;
    private b5;
    b7(a: Path, b: number, c: number, d: number): void;
    b8(a: Brush): Brush;
    protected a3(a: RenderingContext, b: boolean): void;
    ai(a: any): void;
}
