import { AnnotationLayer } from "./AnnotationLayer";
import { Series } from "./Series";
import { FinalValueSelectionMode } from "./FinalValueSelectionMode";
import { Brush } from "igniteui-angular-core/ES5/Brush";
import { Thickness } from "igniteui-angular-core/ES5/Thickness";
import { FinalValueLayerFrame } from "./FinalValueLayerFrame";
import { Type } from "igniteui-angular-core/ES5/type";
import { SeriesView } from "./SeriesView";
import { Frame } from "./Frame";
import { AnnotationLayerView } from "./AnnotationLayerView";
/**
 * @hidden
 */
export declare class FinalValueLayer extends AnnotationLayer {
    static $t: Type;
    constructor();
    protected bf(): SeriesView;
    it(a: SeriesView): void;
    protected m4: FinalValueLayerView;
    m6: Series;
    m5: FinalValueSelectionMode;
    n6: Brush;
    n4: Brush;
    nf: number;
    n5: Brush;
    readonly n8: Thickness;
    nb: number;
    nd: number;
    nc: number;
    na: number;
    axisAnnotationFormatLabel: (item: any) => string;
    m7(): boolean;
    ne: number;
    protected mk(a: Series, b: boolean): void;
    protected mm(a: Frame, b: SeriesView): void;
    protected l7(a: Series): boolean;
    im(): void;
    private n7;
    private nr;
    private m9;
    private m8;
    protected ns(a: FinalValueLayerFrame, b: boolean): void;
    protected mp(a: Frame, b: SeriesView): void;
    protected c8(): boolean;
    protected iy(a: any, b: string, c: any, d: any): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class FinalValueLayerView extends AnnotationLayerView {
    static $t: Type;
    constructor(a: FinalValueLayer);
    protected b1: FinalValueLayer;
    ap(): void;
    b2(a: Brush): Brush;
    ai(a: any): void;
}
