import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IndicatorCalculationStrategy } from "./IndicatorCalculationStrategy";
import { Type } from "igniteui-angular-core/ES5/type";
import { DependencyProperty } from "igniteui-angular-core/ES5/DependencyProperty";
/**
 * @hidden
 */
export declare class FullStochasticOscillatorIndicator extends StrategyBasedIndicator {
    static $t: Type;
    constructor();
    protected get_qb(): IndicatorCalculationStrategy;
    protected readonly qb: IndicatorCalculationStrategy;
    protected get_qo(): Type;
    protected readonly qo: Type;
    qw: number;
    static readonly q1: DependencyProperty;
    protected qh(): number;
    qq(a: number): void;
    smoothingPeriod: number;
    static readonly q2: DependencyProperty;
    protected qj(): number;
    qy: number;
    static readonly q3: DependencyProperty;
    protected qg(): number;
    protected pr(): number;
}
