import { Series } from "./Series";
import { NumericXAxis } from "./NumericXAxis";
import { NumericYAxis } from "./NumericYAxis";
import { IFastItemColumn$1 } from "igniteui-angular-core/ES5/IFastItemColumn$1";
import { Color } from "igniteui-angular-core/ES5/Color";
import { Type, Point } from "igniteui-angular-core/ES5/type";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { Axis } from "./Axis";
import { SeriesView } from "./SeriesView";
import { ProgressiveLoadStatusEventArgs } from "./ProgressiveLoadStatusEventArgs";
import { FastItemsSourceEventAction } from "igniteui-angular-core/ES5/FastItemsSourceEventAction";
import { AxisRange } from "./AxisRange";
import { RenderSurface } from "./RenderSurface";
import { RenderingContext } from "igniteui-angular-core/ES5/RenderingContext";
/**
 * @hidden
 */
export declare class HighDensityScatterSeries extends Series {
    static $t: Type;
    constructor();
    protected get_c4(): boolean;
    l6: NumericXAxis;
    l8: NumericYAxis;
    n2: string;
    protected md: IFastItemColumn$1<number>;
    private mc;
    fs(a: any, b: string): any;
    n6: string;
    protected mf: IFastItemColumn$1<number>;
    private me;
    mm: boolean;
    ml: boolean;
    ne: number;
    nd: number;
    oz: Color;
    oy: Color;
    nq: number;
    private ok;
    protected iy(a: any, b: string, c: any, d: any): void;
    mk(a: any): boolean;
    mj(a: any): boolean;
    private ob;
    private nk;
    private mg;
    private m0;
    private mz;
    private my;
    private mx;
    private mw;
    private mv;
    private m3;
    private m2;
    private m1;
    private l4;
    private l9;
    private ma;
    private l5;
    private l7;
    private mi;
    dw(a: Rect, b: Rect, c: SeriesView): boolean;
    private nl;
    nr: number;
    jd(a: boolean): void;
    private od;
    private nn;
    private nh;
    private ng;
    protected hy(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    private oa;
    private of;
    private oe;
    progressiveLoadStatusChanged: (sender: any, e: ProgressiveLoadStatusEventArgs) => void;
    private n8;
    private oc;
    private mn;
    private om;
    private mt;
    private ms;
    private mu;
    private m6;
    private m4;
    private m5;
    private m7;
    private m9;
    private nb;
    private na;
    private m8;
    private mp;
    private mq;
    private mr;
    private mo;
    private oh;
    c9(a: any): boolean;
    private oj;
    private no;
    private np;
    private nc;
    private oi;
    private og;
    private nj;
    private ni;
    private l1;
    private nm;
    private n9;
    protected bf(): SeriesView;
    it(a: SeriesView): void;
    protected l3: HighDensityScatterSeriesView;
    an(a: Axis): AxisRange;
    private mh;
    protected jr(a: Rect, b: Rect): void;
    protected js(a: Rect, b: Rect): void;
    private _itemIndexes;
    private l2;
    private lz;
    fp(a: Point): any;
    private ns;
    ol(a: number[], b: number, c: number): void;
    protected get_dq(): boolean;
    protected set_dq(a: boolean): void;
    hv(a: boolean, b: SeriesView): void;
    je(a: Rect, b: RenderSurface): void;
    private mb;
    jb(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    ht(): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class HighDensityScatterSeriesView extends SeriesView {
    static $t: Type;
    constructor(a: HighDensityScatterSeries);
    ap(): void;
    b7(): void;
    protected bw: HighDensityScatterSeries;
    private bu;
    private b2;
    private b1;
    private bz;
    private b0;
    private bx;
    b3(): void;
    bv(): number[];
    b6(): void;
    b5(a: () => void): void;
    protected a3(a: RenderingContext, b: boolean): void;
    by(a: Color, b: Color): boolean;
    b4(): void;
    ai(a: any): void;
}
