import { Series } from "./Series";
import { IFastItemColumn$1 } from "igniteui-angular-core/ES5/IFastItemColumn$1";
import { IEnumerable, Type } from "igniteui-angular-core/ES5/type";
import { NumericXAxis } from "./NumericXAxis";
import { NumericYAxis } from "./NumericYAxis";
import { IFastItemsSource } from "igniteui-angular-core/ES5/IFastItemsSource";
import { TriangulationStatusEventArgs } from "igniteui-angular-core/ES5/TriangulationStatusEventArgs";
import { Axis } from "./Axis";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { SeriesView } from "./SeriesView";
import { FastItemsSourceEventAction } from "igniteui-angular-core/ES5/FastItemsSourceEventAction";
import { AxisRange } from "./AxisRange";
/**
 * @hidden
 */
export declare abstract class ScatterTriangulationSeries extends Series {
    static $t: Type;
    ht(): void;
    mx: string;
    fs(a: any, b: string): any;
    m1: string;
    private l6;
    protected mc: IFastItemColumn$1<number>;
    private l7;
    protected md: IFastItemColumn$1<number>;
    lz: NumericXAxis;
    l0: NumericYAxis;
    private mf;
    jd(a: boolean): void;
    private m5;
    private m3;
    private l2;
    triangulationStatusChanged: (sender: any, args: TriangulationStatusEventArgs) => void;
    private m6;
    protected l8(a: IFastItemsSource, b: string): IFastItemColumn$1<number>;
    protected iy(a: any, b: string, c: any, d: any): void;
    mh(a: any): boolean;
    mg(a: any): boolean;
    dw(a: Rect, b: Rect, c: SeriesView): boolean;
    private m4;
    private mi;
    ia(): void;
    protected hy(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    an(a: Axis): AxisRange;
    protected js(a: Rect, b: Rect): void;
    protected jr(a: Rect, b: Rect): void;
    trianglesSource: IEnumerable;
    me: IFastItemsSource;
    mp: string;
    mr: string;
    mt: string;
    private l3;
    protected l9: IFastItemColumn$1<number>;
    private l4;
    protected ma: IFastItemColumn$1<number>;
    private l5;
    protected mb: IFastItemColumn$1<number>;
    protected get_c5(): boolean;
    static $$p: string[];
}
