import { Series } from "./Series";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { Axis } from "./Axis";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { Type, Point } from "igniteui-angular-core/ES5/type";
import { Brush } from "igniteui-angular-core/ES5/Brush";
import { Thickness } from "igniteui-angular-core/ES5/Thickness";
import { SeriesView } from "./SeriesView";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { AxisRange } from "./AxisRange";
import { Geometry } from "igniteui-angular-core/ES5/Geometry";
import { FastItemsSourceEventAction } from "igniteui-angular-core/ES5/FastItemsSourceEventAction";
import { CategoryMode } from "./CategoryMode";
import { RenderSurface } from "./RenderSurface";
import { RenderingContext } from "igniteui-angular-core/ES5/RenderingContext";
/**
 * @hidden
 */
export declare class ValueOverlay extends Series implements IHasCategoryModePreference {
    static $t: Type;
    constructor();
    lz: Axis;
    mh: number;
    mf: number;
    mg: number;
    mc: number;
    en(a: Point, b: boolean, c: boolean): number;
    md(a: Point, b: Point): number;
    lk(a: Point, b: boolean, c: boolean): Point;
    e8(a: Point): number;
    fp(a: Point): any;
    c9(a: any): boolean;
    an(a: Axis): AxisRange;
    jd(a: boolean): void;
    me(): number;
    my(a: number, b: ValueOverlayView): void;
    dw(a: Rect, b: Rect, c: SeriesView): boolean;
    protected js(a: Rect, b: Rect): void;
    protected jr(a: Rect, b: Rect): void;
    protected hy(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected iy(a: any, b: string, c: any, d: any): void;
    ia(): void;
    hv(a: boolean, b: SeriesView): void;
    private l4;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    readonly categoryAxis: CategoryAxisBase;
    protected bf(): SeriesView;
    it(a: SeriesView): void;
    private l2;
    je(a: Rect, b: RenderSurface): void;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    l3: boolean;
    l1: (item: any) => string;
    nf: Brush;
    nd: Brush;
    mi: number;
    ne: Brush;
    readonly ng: Thickness;
    l8: number;
    ma: number;
    l9: number;
    l7: number;
    mb: number;
    ag(): Axis[];
    private l0;
    private l6;
    private l5;
    protected mz(a: number, b: boolean): void;
    protected get_c6(): boolean;
    mu(a: number): string;
    readonly mw: string;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ValueOverlayView extends SeriesView {
    static $t: Type;
    constructor(a: ValueOverlay);
    private bw;
    protected a8(): void;
    protected a9(): void;
    bv(a: Geometry): void;
    bu(): void;
    protected a3(a: RenderingContext, b: boolean): void;
    ai(a: any): void;
}
